<?php // Include only
if (!defined ('BOOT')) exit ('No bootstrap.  Exiting.');

/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wax Poteto modifications Copyright Marc "Waccoon" Leveille
http://www.NineChime.com/products/
Version 5.8.9 - Last modified 10/20/2012

Requires:
	Preset $OekakiU and $OekakiPass if they are not cookies

Control variables:
	$no_online, $quiet_mode

Note:  Do not print anything in $quiet_mode unless it's a security problem, or else applets will freak out.  Just flush everything or use w_log().
*/


// Control variables
{
	// TRUE to disable online check
	if (!isset ($no_online))
		$no_online = FALSE;

	// TRUE to disable output (satisfies paint applets)
	if (!isset ($quiet_mode))
		$quiet_mode = FALSE;
}


// HTML DOCTYPE and HEAD reference
// Defined here (and not common.php), so test changes are tied to version number
function send_html_headers($override = '') {
	global $charset, $metatag_language, $use_compress;
	// requires $zlib

	if ($use_compress) {
		if (ob_get_length() > 0) {
			@ob_flush();
		}
		if (!headers_sent() && ob_start('ob_gzhandler')) {
			$GLOBALS['zlib'] = TRUE;
		}
	}

	if (!empty ($charset)) {
		header ("Content-Type: text/html; charset={$charset}");
	}
	if (!empty ($metatag_language)) {
		header ("Content-Language: {$metatag_language}");
	}

	if ($override == 'html') {
	?>
<!DOCTYPE html PUBLIC
	"-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<?php
	} else {
	?>
<!DOCTYPE html PUBLIC
	"-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<?php
	}
}


function get_compress_okay() {
	global $use_compress;

	if (!$use_compress
		|| !extension_loaded('zlib')
		|| @ini_get('zlib.output_compression')
		|| @ini_get('zlib.output_compression') === FALSE // Detection blocked?
		|| @ini_get('output_handler') == 'ob_gzhandler')
	{
		return FALSE;
	}

	if (! ($agent = $_SERVER['HTTP_USER_AGENT'])) {
		// Running as CGI
		return FALSE;
	}

	if (strpos(strtolower($_SERVER['HTTP_ACCEPT_ENCODING']), 'gzip') === FALSE) {
		// Either Mosaic or archaic.  ;)
		return FALSE;
	}

	// Use on popular browser engines only?
	if (defined('LAZY_COMPRESS') && LAZY_COMPRESS) {
		if (strpos ($agent, 'WebKit') === FALSE
			&& strpos ($agent, 'Gecko') === FALSE
			&& strpos ($agent, 'Opera') === FALSE)
		{
			return FALSE;
		}
	}

	// Some versions of IE can't handle gzip correctly
	if (strpos ($agent, 'MSIE ') !== FALSE) {
		if (strpos ($agent, 'Maxthon') === FALSE
			&& strpos ($agent, 'MyIE2') === FALSE)
		{
			if (preg_match("/MSIE ([0-9]{1,}[\.0-9]{0,})/", $agent, $matches)
				&& (floatval($matches[1]) < 7.0))
			{
				return FALSE;
			}
		}
	}
	return TRUE;
}


// ===================================================================
// Includes
//
$debug            = FALSE;
$wactest          = FALSE;
$maintenance_mode = FALSE;
$zlib             = FALSE;
$version             = '5.8.9'; // Format: M.m.r
$cfg_ver_check       = '1.5.5'; // Config version required
$cfg_db_file_check   = '1.5.0'; // Version marker in database config file
$cfg_db_tables_check = '1.5.5'; // Version marker in database tables

// PHP Version
if (!defined ('PHP_VERSION_ID')) {
	$my_version = explode ('.', PHP_VERSION);
	define ('PHP_VERSION_ID', ($my_version[0] * 10000 + $my_version[1] * 100 + $my_version[2]));
}

// Autoglobal clean
$usrflags = NULL;
$row      = array();
$cookie_path   = '';
$cookie_domain = '';
$edittemplate  = '';
$header_extra_metatags = ''; // Additional <meta> tags for header
$header_extra_script = ''; // Mostly for applets
$mb_blink_o = '';
$mb_blink_c = '';
$vp_blink_o = '';
$vp_blink_c = '';
$stupid_name  = '';
$stupid_guest = '';

// Dates
$datef = array();
$datef['post_header'] = 'l, F jS Y, g:i A';
$datef['admin_edit']  = 'F j, Y, g:i a';
$datef['chat']        = 'H:i';
$datef['birthdate']  = 'Y/n/j';
$datef['birthmonth'] = 'Y/n';
$datef['birthyear']  = 'Y';


// Get config
$cfg = array();
if (!@include ('config.php')) {
	if (!file_exists ('dbconn.php')) {
		exit ("<html>\n<body>\n<p>Welcome to Wax Poteto!</p>\n<p><a href=\"install.php\">Click here to run the installer</a>.</p>\n</body>\n</html>");
	} else {
		exit('Cannot open config file!');
	}
} else {
	// Check version
	if ($cfg['version'] != $cfg_ver_check) {
		exit("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Config required: v{$cfg_ver_check}<br />Config present: v{$cfg['version']}</p>\n</body>\n</html>");
	}

	// ===================================================================
	// Hacks! (requires config, call before startup/common.php)
	// Included here since boot.php is used on EVERY page, and hacks may be security/user related
	//
	if (file_exists ($cfg['res_path'].'/'.'hacks.php')) {
		define ('HACK_CHECK', 1); // Version control
		include ($cfg['res_path'].'/'.'hacks.php');
	}
}


// Get database
{
	require ('db_layer.php');

	$dbconn = db_open();

	// Check db version
	if ($cfg_db_file_check != $cfg_db['version']) {
		db_close();
		exit ("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Database required: v{$cfg_db_file_check}<br />DB config file present: v{$cfg_db['version']}</p>\n</body>\n</html>");
	}
	$result = db_query ("SELECT miscstring FROM {$db_p}oekakimisc WHERE miscname='dbversion'");
	$db_temp = db_result ($result);
	if ($db_temp != $cfg_db_tables_check) {
		db_close();
		exit ("<html>\n<body>\n<p>Please run the <a href=\"update.php\">updater</a>.</p>\n<p>Database required: v{$cfg_db_tables_check}<br />Tables present: v{$db_temp}</p>\n</body>\n</html>");
	}
	unset ($dbtemp);
}


// Easy fixes
if (!defined ('MIN_AGE_ADULT')) {
	define ('MIN_AGE_ADULT', 18);
}
if (!defined ('ACTIVE_LOGIN_TIME_DAYS')) {
	define ('ACTIVE_LOGIN_TIME_DAYS', 180);
}


// ===================================================================
// Startup
//

// E_ALL still needs some more testing, and can cause date() errors
// on servers without locale or timezones set correctly.
if (isset ($wactest) && $wactest) {
	//error_reporting (E_ALL);
	error_reporting (E_ALL | E_STRICT);
} else {
	error_reporting (E_ALL ^ E_NOTICE);
}

// Critical functions
require ('common.php');


// ===================================================================
// GPC
//

// Main
$mode    = w_gpc('mode', 'a');
$action  = w_gpc('action', 'a');
$pageno  = w_gpc('pageno', 'i+');
$sort    = w_gpc('sort', 'i+');
$artist  = w_gpc('artist');
$a_match = w_gpc('a_match');
$t_match = w_gpc('t_match');


// Login validation
// If not set elsewhere (ex: by applets), we import cookies here
if (!isset ($OekakiU) && !isset ($OekakiPass)) {
	$OekakiU    = '';
	$OekakiPass = '';
	if (isset ($_COOKIE['OekakiU']) && isset ($_COOKIE['OekakiPass'])) {
		$OekakiU    = $_COOKIE['OekakiU'];
		$OekakiPass = $_COOKIE['OekakiPass'];
	}
}
$OekakiID   = '';
$OekakiU    = addslashes (str_replace ('\\', '', $OekakiU));
$OekakiPass = addslashes (str_replace ('\\', '', $OekakiPass));


// ===================================================================
// Init
//

// Benchmark
$start_time = get_microtime();

// Cookies
$cookie_life = 2419200; // in seconds

// GZip/ZLib compression for HTML
$use_compress  = TRUE;
if (defined ('DISABLE_HTML_COMPRESSION') && DISABLE_HTML_COMPRESSION
	|| !get_compress_okay())
{
	$use_compress = FALSE;
}

// User info
$user  = array(); // SQL user data
$user['no_viewer'] = 0; // Another hack

$flags = array(); // Permission flags
$flags['all']    = $usrflags;
$flags['member'] = 0; // Is a registered member
$flags['G']      = 0; // Is a registered member (old flag)
$flags['mod']    = 0; // Is a moderator
$flags['admin']  = 0; // Is an admin
$flags['sadmin'] = 0; // Is a super admin
$flags['owner']  = 0; // Is owner
$flags['rank']   = 0; // (0-9)
$flags['D']      = 0; // Draw access
$flags['M']      = 0; // Anim access
$flags['I']      = 0; // Immunity
$flags['U']      = 0; // Upload access
$flags['X']      = 0; // Adult access

// Admin rank numbers
define ('RANK_MOD',    4);
define ('RANK_ADMIN',  5);
define ('RANK_SADMIN', 7);
define ('RANK_OWNER',  9);

// Cache control
//
// NOTE: we can't rely on the database to provide signed ints, so "forever"
// dates should be reasonably in the future.  Do NOT use the cache for long-
// term storage, so anything more than a few years is not reasonable.
define ('CACHE_EXPIRE',       864000);    // 15 days (default)
define ('CACHE_EXPIRE_LONG',  15768000);  // 6 months
define ('CACHE_EXPIRE_NEVER', 157680000); // Ought to be enough for anybody
define ('CACHE_EXPIRE_NOW',   0);

// Import init (needs config)
$language = $cfg['language'];
$template = $cfg['template'];

// Picture and thumbnail logic
$p_pic = $cfg['op_pics'].'/'.$cfg['op_pre'];
$t_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'t';
$r_pic = $cfg['op_pics'].'/'.$cfg['op_pre'].'r';
$p_prefix = $cfg['op_pre'];
$t_prefix = $cfg['op_pre'].'t';
$r_prefix = $cfg['op_pre'].'r';

// Mailbox
$mail_status = array();
$mail_status['new']     = 0;
$mail_status['unread']  = 1;
$mail_status['read']    = 2;
$mail_status['replied'] = 3;


// ===================================================================
// Process Registration
//
if (!empty ($OekakiU) && !empty ($OekakiPass)) {
	$result = db_query ("SELECT * FROM {$db_mem}oekaki WHERE usrname='$OekakiU'");
	if ($result) {
		if (db_num_rows ($result)) {
			$user = @db_fetch_array ($result);

			// Verify password
			if ($OekakiPass == $user['usrpass']) {
				// Verify active (non-pending)
				if (strstr ($user['usrflags'], 'G') && !strstr ($user['usrflags'], 'P')) {
					// Note: pending members should not have cookies!
					$flags['member'] = 1;
					$OekakiID = w_toalpha($user['ID']);
				}
			}
		}
	} else {
		// It's serious to have SQL bomb here
		w_log_sql('boot:'.__LINE__);

		if (!$quiet_mode) {
			// Not quiet mode?  DIE!
			w_exit ('Login failed due to a server error.  If the problem persists, ask the admin to check the oekaki log.');
		}

		// Flush for quiet mode
		$user = array();
	}


	// If SQL works and registration checks out
	if ($flags['member']) {
		// Get flags ($usrflags, $rank)
		$flags = parse_flags ($user['usrflags'], $user['rank']);

		//
		// Get language, template
		// Blank for either means use default
		//
		if (!empty ($user['language'])) {
			$language = $user['language'];
		}
		if (!empty ($user['templatesel'])) {
			$template = $user['templatesel'];
		}

		//
		// Update last login
		//
		if (!$maintenance_mode) {
			$result = @db_query ("UPDATE {$db_mem}oekaki SET lastlogin=NOW() WHERE usrname='$OekakiU'");
		}

	} else {
		// Password didn't match up!  Clear user info
		$OekakiU = '';
		$OekakiPass = '';
		$user = array();

		if (!$quiet_mode) {
			if ($debug) {
				echo 'Cookie Reset';
			} else {
				w_unset_cookie ('OekakiU');
				w_unset_cookie ('OekakiPass');
			}
		}

		// Note: don't redirect here, or an infinate loop may result.
	}
}

// Is the board in maintenance mode?
if ($maintenance_mode) {
	if (!$flags['owner']) {
		w_exit("<html>\n<body>\n<h2>The oekaki is down for maintenance</h2>\n<p>It should be back online shortly.  Send all quesions to <a href=\"mailto:{$cfg['op_email']}\">".email_code($cfg['op_email'])."</p>\n</body>\n</html>");
	}
}


// ===================================================================
// Ban list
// BAN_OVERRIDE is for hacks, BAN_KILL is internal use only
//
// Get IP and hostname
$address  = 'invalid';
$hostname = '';
if (!empty ($_SERVER['REMOTE_ADDR'])) {
	$address = $_SERVER['REMOTE_ADDR'];
	if (defined ('ENABLE_DNS_HOST_LOOKUP') && ENABLE_DNS_HOST_LOOKUP) {
		$hostname = @gethostbyaddr ($address);
	} else {
		$hostname = '';
	}
}

if (! (defined ('BAN_OVERRIDE') && BAN_OVERRIDE)) {
	if (! (defined ('BAN_KILL') && BAN_KILL)) {
		// !hacks.php
		require ('banscript.php');
	}
}

// Track IP after loading ban list
if (!empty ($OekakiU) && !empty ($OekakiPass)) {
	$result = db_query ("UPDATE `{$db_mem}oekaki` SET `IP`='{$address}' WHERE `usrname`='$OekakiU'");
}


// ===================================================================
// If registered or non-registered
//

// Needed in quiet mode for error reporting
include ('language/'.$language.'.php');

// Check for quiet mode.
if (!$quiet_mode) {

	// Import niftytoo
	require ('niftytoo.php');

	// Set template (Wacintaki style)
	$template_name = $template;
	$template_file = $cfg['tpl_path'].'/'.$template;

	// Set layout, thumbnail
	if ($flags['member']) {
		$display = $user['picview'];
		$screensize = 800;
		if ($user['screensize'] > 0) {
			$screensize = $user['screensize'];
		}

//		if ($cfg['force_thumb'] == 'yes' || $user['thumbview'] == 0) {
			$thumbDisplay = $cfg['use_thumb'];
//		} else {
//			$thumbDisplay = $user['thumbview'];
//		}

		// Account "Screenshot" disables thumbnails
		if (strtolower ($OekakiU) == 'screenshot') {
			$thumbDisplay = 0;
		}
	} else {
		$display = 0;
		$screensize = 800;
		$thumbDisplay = $cfg['use_thumb'];
	}


	// Check installer, updater.  For effiency and to resolve conflicts
	// with non-installed boards, check for admin cookies only.
	if ($action == 'secure') {
		$my_fail = 0;
		if (file_exists('install.php')) {
			if (@unlink('install.php')) {
				echo ("Installer removed<br />\n");
			} else {
				echo ("Installer removal failed!<br />\n");
				$my_fail++;
			}
		}
		if (file_exists('update.php')) {
			if (@unlink ('update.php')) {
				echo ("Updater removed<br />\n");
			} else {
				echo ("Updater removal failed!<br />\n");
				$my_fail++;
			}
		}
		if ($my_fail) {
			w_exit("<p>Remove the files manually via FTP</p>");
		} else {
			w_exit("<p><a href=\"index.php\">Proceed to index page</a></p>");
		}
	}
	if ($flags['admin']) {
		if (file_exists ('install.php') || file_exists ('update.php')) {
			w_exit("<html>\n<body>\n<p>&ldquo;install.php&rdquo; and/or &ldquo;update.php&rdquo; still exists!</p>\nIf you do not need them anymore, <a href=\"index.php?action=secure\">click here to remove them</a>.</p>\n<p>If you get this error again, delete the files manually via FTP.</p>\n</body>\n</html>");
		}
	}


	// ===================================================================
	// Template
	//
	// Due to a template format change, we need to filter some globals
	// and set variables if we encounter an old template
	//
	// We need to set some attributes in the <body> tag for old templates
	//
	$textColor='';
	$link='';
	$aLink='';
	$vLink='';
	$dStamp='';
	$hWidth='';
	$hCellPadding='';
	$cWidth='';
	$cCellPadding='';
	$bgColor='';
	$bgImage='';

	ob_start();
		include ('templates/'.$template.'.php');
		$cssdata = ob_get_contents();
	ob_clean();


	$bodydata = '';
	if (isset ($textColor) && !empty ($textColor)) {
		// Old template
		$bodydata .= 'style="margin: 0 0 0 0;" text="'.$textColor.'" link="'.$link.'" vlink="'.$vLink.'" alink="'.$aLink.'"';
	}
	if (!empty ($bgColor)) {
		$bodydata .= ' bgcolor="'.$bgColor.'"';
	}
	if (!empty ($bgImage) && strpos ($bgImage, '://') === FALSE) {
		// NOT a good idea to allow off-site images here
		$bodydata .= ' background="templates/'.$bgImage.'"';
	}


	// ===================================================================
	// Online
	//
	if (!$no_online) {
		if (!empty ($_SERVER['PHP_SELF'])) {
			// Fixes servers using PHP as a runtime and not as a module
			$my_script = $_SERVER['PHP_SELF'];
		} else {
			$my_script = $SCRIPT_NAME;
		}

		// Due to popular demand, locations are back.
		// Useful for debugging, too, so almost all scripts are included
		if (empty ($my_script)) {
			$my_script = 'Unknown';
		} else {
			$loc_list = array (
				'index'=>$langop_word_view,
				'chat'=>$langop_word_chat,
				'addusr'=>$langop_header_vpending,
				'banlist'=>$langop_header_banlist,
				'chibipaint'=>'Chibi Paint',
				'chngpass'=>$langop_eprofile_chngpass,
				'comment.'=>$langop_word_commenting,
				'cpanel'=>$langop_header_cpanel,
				'delcomments.'=>$langop_header_dcomm,
				'delpics.'=>$langop_header_dpics,
				'delusr'=>$langop_common_delusr,
				'draw'=>'Draw Screen',
				'edit_avatar'=>$langop_avatar_change,
				'editbanner'=>$langop_header_ebanner,
				'editcomm'=>$langop_ecomm_title,
				'editnews'=>$langop_enews_title,
				'editnotice'=>$langop_enotice_title,
				'editpic'=>$langop_header_epics,
				'editprofile'=>$langop_eprofile_title,
				'editrules'=>'Edit Rules',
				'faq'=>$langop_word_faq,
				'lcommentdel'=>$langop_header_ecomm,
				'ldelpics'=>$langop_header_epics,
				'lostpass'=>$langop_precover_title,
				'mail'=>$langop_word_mailbox,
				'massmail'=>$langop_word_mailbox,
				'memberlist'=>$langop_mlist_title,
				'modflags'=>$langop_niftytoo_permissions,
				'newpass'=>$langop_precover_title,
				'noteBBSa'=>$langop_online_aninbbs,
				'noteBBS'=>$langop_online_palpaintbbs,
				'oekakiBBSa'=>$langop_online_aniobbs,
				'oekakiBBS'=>$langop_online_nmrlobbs,
				'paintBBS'=>$langop_online_npaintbbs,
				'profile'=>'Profile Viewer',
				'recover'=>$langop_picrecover_title,
				'register'=>$langop_install_reg,
				'renameusr'=>$langop_o_renameusr,
				'retouch'=>'Retouch',
				'shiBBS'=>$langop_word_shipainter,
				'showrules'=>'Rules',
				'testinfo'=>'Diagnostics',
				'upload'=>$langop_word_upload,
				'viewani'=>$langop_viewani_title,
				'whosonline'=>$langop_word_online,
				'tdesign'=>$langop_header_tdesign,
				'tedita'=>$langop_header_tdesign,
				'tedit'=>$langop_header_tdesign,
				'tnewa'=>$langop_header_tdesign,
				'tnew'=>$langop_header_tdesign
			);

			$loc = $langop_word_view;
			foreach ($loc_list as $loc_key=>$loc_val) {
				if (strpos ($my_script, $loc_key) !== FALSE) {
					$loc = $loc_val;
					break;
				}
			}
		}

		// Maintenance
		if ($loc != $langop_word_chat && $loc != $langop_word_online) {
			$online = db_query ("DELETE FROM {$db_mem}oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 15 MINUTE) < NOW())");

			$online = db_query ("DELETE FROM {$db_mem}oekakionline WHERE (DATE_ADD(onlinetime, INTERVAL 1 MINUTE) < NOW()) AND locale='{$langop_word_chat}'");
		}

		if ($flags['member'] && !empty ($OekakiU) && $loc != $langop_word_online) {
			$result = db_query ("SELECT onlineusr FROM {$db_mem}oekakionline WHERE onlineusr='{$OekakiU}'");

			if (db_num_rows ($result)) {
				$online = db_query ("UPDATE {$db_mem}oekakionline SET onlinetime=NOW(), locale='{$loc}', onlineboard='".addslashes ($cfg['op_title'])."' WHERE onlineusr='{$OekakiU}'");
			} else {
				$online = db_query ("INSERT INTO {$db_mem}oekakionline SET onlineusr='{$OekakiU}', onlinetime=NOW(), onlineIP='{$address}', locale='{$loc}', onlineboard='".addslashes ($cfg['op_title'])."'");
			}
		}
	} // End Online

} // End quiet mode



// Regular maintenance
// For now, we'll only run this during normal browsing, not on a scheduler
if (!$quiet_mode && empty ($mode) && empty ($action)) {
	require ('maint.php');
}

?>